#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <math.h>
#include <INA226_WE.h>


#define SCREEN_WIDTH 128
#define SCREEN_HEIGHT 64
#define OLED_RESET 4
#define I2C_ADDRESS 0x40
Adafruit_SSD1306 display(OLED_RESET);
//INA226 INA(0x40);
  float shuntVoltage_mV = 0.000;
  float busVoltage_V = 0.000;
  float current_A = 0.000;
  float loadVoltage_V = 0.000;
  float x;
  float z;
  float y;


INA226_WE ina226 = INA226_WE(0x40);


void setup() {
  Wire.begin();
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  Serial.begin(9600);
  ina226.init();
  ina226.setResistorRange(0.00515,10.0);
  ina226.waitUntilConversionCompleted();
  ina226.setConversionTime(CONV_TIME_140);
  ina226.setAverage(AVERAGE_256);
  pinMode(2,OUTPUT);
  }

void loop() {
 


 // ina226.setCorrectionFactor(1);
  //ina226.readAndClearFlags();
  shuntVoltage_mV = ina226.getShuntVoltage_mV();
  busVoltage_V = (ina226.getBusVoltage_V());
  current_A = ina226.getCurrent_mA()/1000;
  if (current_A <=0) {
    x = 0.000;
  } 
  else{
    x = current_A;
  }
  if (busVoltage_V >= 10){
    z = 18;
  }
  else {
    z = 30;
  }
  if ( current_A >= 10){
    y = 18;
  }
  else {
    y = 30;
  }
  display.clearDisplay();
  display.setTextColor(WHITE);
  display.setTextSize(2);
  display.setCursor(z,0);
  display.print(busVoltage_V,3);
  display.setCursor(110,0);
  display.print("V      ");
  display.setTextColor(WHITE);
  display.setTextSize(2);
  display.setCursor(y,18);
  display.print(x,3);
  display.setCursor(110,18);
  display.print("A      ");
  display.display();
  Serial.println(shuntVoltage_mV,5);
  
  

}